﻿class Bresline {

  function mouseDrag(x:Object,y:Object,x1:Object,y1:Object,curcol:Object,mov:Object){
     var xinc1,xinc2,yinc1,yinc2,num,numadd,numpixels,den;
     var x2 = (x>>5);
     var y2 = (y>>5);
x1/=32;y1/=32;
     //trace(x2+"  "+y2);
     
     if(x2<0 || x2>31 || y2<0 || y2>31) return ;
     var deltax = Math.abs(x2 - x1);        // The difference between the x's
     var deltay = Math.abs(y2 - y1);        // The difference between the y's
     x = x1;                       // Start x off at the first pixel
     y = y1;                       // Start y off at the first pixel

     if (x2 >= x1){                 // The x-values are increasing
       xinc1 = 1;
       xinc2 = 1;
     }else{                          // The x-values are decreasing
       xinc1 = -1;
       xinc2 = -1;
     }

     if (y2 >= y1){                 // The y-values are increasing
       yinc1 = 1;
       yinc2 = 1;
     }else{                          // The y-values are decreasing
       yinc1 = -1;
       yinc2 = -1;
     }

     if (deltax >= deltay){         // There is at least one x-value for every y-value
       xinc1 = 0;                  // Don't change the x when numerator >= denominator
       yinc2 = 0;                  // Don't change the y for every iteration
       den = deltax;
       num = Math.floor(deltax / 2);
       numadd = deltay;
       numpixels = deltax;         // There are more x-values than y-values
     }else{ 			   // There is at least one y-value for every x-value
       xinc2 = 0;                  // Don't change the x for every iteration
       yinc1 = 0;                  // Don't change the y when numerator >= denominator
       den = deltay;
       num = Math.floor(deltay / 2);
       numadd = deltax;
       numpixels = deltay;         // There are more y-values than x-values
     }

     for (var curpixel = 0; curpixel <= numpixels; curpixel++){
         mov.beginFill(curcol, 100);
         mov.moveTo(x*32, y*32);
         mov.lineTo(32+x*32, y*32);
         mov.lineTo(32+x*32, 32+y*32);
         mov.lineTo(x*32, 32+y*32);
         mov.endFill();
       num += numadd;              // Increase the numerator by the top of the fraction
       if (num >= den)             // Check if numerator >= denominator
       {
         num -= den;               // Calculate the new numerator value
         x += xinc1;               // Change the x as appropriate
         y += yinc1;               // Change the y as appropriate
       }
       x += xinc2;                 // Change the x as appropriate
       y += yinc2;                 // Change the y as appropriate
     }
     x1 = x2;
     y1 = y2;
     return;
   }

}
